package com.sheca.shcagmseckit;

//import android.annotation.SuppressLint;
//import android.content.Context;

//import org.json.JSONObject;
//import android.provider.Settings;
//import android.telephony.TelephonyManager;

public class shcaGmSecKit {
	
	private static shcaGmSecKit sdk = null;
	
	private int gLastErrorCode = 0;
	
    static {
        System.loadLibrary("shcaGmSecKit");
    }
    
    private shcaGmSecKit(){
    	
    }
    
    public static shcaGmSecKit getIntence(){
    	if (sdk == null){
    		sdk = new shcaGmSecKit();
    	}
    	return sdk;
    }

    /**
     * 
     * @return
     */
    public int getLastErrCode(){
    	return gLastErrorCode;
    }    
    
    /**
     * 
     */
    public void debug4Test(){
    	return;
//    	String o = priUCM_Client_CreateSM2SignKey4Share();
//    	//System.out.println(o);
//    	try {
//    		int retCode = 0;
//    		JSONObject json_tmp = null;
//			JSONObject json_client = new JSONObject(o);//d1,d1_inv,p1
//			//
//			JSONObject json_server = new JSONObject();
//			json_server.put("p1", json_client.getString("p1"));
//			
//			o = priUCM_Server_CreateSM2KeyShare( json_server.toString() );
//			json_tmp = new JSONObject(o);//d2,d2_inv,pubkey
//			json_server.put("d2", json_tmp.getString("d2"));
//			json_server.put("d2_inv", json_tmp.getString("d2_inv"));
//			json_server.put("pubkey", json_tmp.getString("pubkey"));
//			json_client.put("pubkey", json_tmp.getString("pubkey"));
//			//			
//			o = priUCM_Server_CreateSM2KeyShareCredential(json_server.toString());
//			json_tmp = new JSONObject(o);
//			
//			json_client.put("cl", json_tmp.getString("cl"));
//			retCode = priUCM_ClientVerifySM2KeyShares(json_client.toString());
//			
//			
//			System.out.println("genKeyPair retCode:"+retCode);
//			
//			json_tmp.put("seed", json_client.getString("pubkey"));
//			retCode = this.priUCM_Quick_Test(json_tmp.toString());
//			System.out.println("priUCM_Quick_Test ret:"+retCode);
//			
//		} catch (Exception e) {
//			e.printStackTrace();
//		}    	
    }
    
    private native String priUCM_Client_CreateSM2SignKey4Share();
    
    private native int priUCM_ClientVerifySM2KeyShares(String jsonReq);
    
    private native String priUCM_Client_CreateSM2SigShareWithPubKey(String jsonReq);
    
    private native String priUCM_Client_AssemblySM2SigEncode(String jsonReq);
    
    private native int priUCM_VerifySM2SigOnDigestWithPubKey(String jsonReq);
    
    private native String priUCM_Server_CreateSM2KeyShare(String jsonReq);
    
    private native String priUCM_Server_CreateSM2KeyShareCredential(String jsonReq);
    
    private native String priUCM_Server_CreateSM2SigShare(String jsonReq);

    private native int priUCM_Quick_Test(String jsonReq);
    
    private native void priSetRandBytesFromServer(byte[] rnd);
    
    private native byte[] priUCM_Sm2EncryptWithCert(byte[] bCert,byte[] raw);
    
    //Please do not use the following APIs in your SDK. 
    private native int priUCM_InitializeHandleWithSeed(byte[] seed);
    
    private native byte[] priUCM_generate_random_bytes(int len);
    
    private native int priUCM_UninitializeHandle();
    
    /**
     * 
     * @param msg
     * @return
     */
    public native String calcSM3(String msg);
        
    /**
     * 
     * @return {d1,d1_inv,p1}
     */
    public String UCM_Client_CreateSM2SignKey4Share(){
    	return priUCM_Client_CreateSM2SignKey4Share();    	
    }    
    
    
    /**
     * 
     * @param {d1,pubkey,cl}
     * @return 0:OK , None 0:NG
     */
    public int UCM_ClientVerifySM2KeyShares(String jsonReq){
    	return priUCM_ClientVerifySM2KeyShares(jsonReq);
    }
        
    /**
     * 
     * @param {pubkey,message}
     * @return {k1,digest,q1}
     */
    public String UCM_Client_CreateSM2SigShareWithPubKey(String jsonReq){
    	return priUCM_Client_CreateSM2SigShareWithPubKey(jsonReq);
    }
    
    /**
     * 
     * @param {d1,k1,r,s2,s3}
     * @return {sig}
     */
    public String UCM_Client_AssemblySM2SigEncode(String jsonReq){    	
    	return priUCM_Client_AssemblySM2SigEncode(jsonReq);
    }

    /**
     * 
     * @param {digest,pubkey,sig}
     * @return 0:OK , None 0:NG
     */
    public int UCM_VerifySM2SigOnDigestWithPubKey(String jsonReq){
    	return priUCM_VerifySM2SigOnDigestWithPubKey(jsonReq);
    }

    /**
     * 
     * @param {p1}
     * @return {d2,d2_inv,pubkey}
     */
    public String UCM_Server_CreateSM2KeyShare(String jsonReq){
    	return priUCM_Server_CreateSM2KeyShare(jsonReq);
    }
        
    /**
     * 
     * @param {d2_inv}
     * @return {cl}
     */
    public String UCM_Server_CreateSM2KeyShareCredential(String jsonReq){
    	return priUCM_Server_CreateSM2KeyShareCredential(jsonReq);
    }
    
    /**
     * 
     * @param {digest,q1,d2}
     * @return {r,s2,s3}
     */    
    public String UCM_Server_CreateSM2SigShare(String jsonReq){
    	return priUCM_Server_CreateSM2SigShare(jsonReq);
    }
    
    /**
     * 
     * @param {seed}
     * @return
     */
    public int UCM_Quick_Test(String jsonReq){
    	return priUCM_Quick_Test(jsonReq);
    }
    
    /**
     * 
     * @param rnd
     */
    public void setRandBytesFromServer(byte[] rnd){
    	priSetRandBytesFromServer(rnd);
    }
    
    /**
     * 
     * @param bCert
     * @param raw
     * @return
     */
    public byte[] UCM_Sm2EncryptWithCert(byte[] bCert,byte[] raw){
    	return (priUCM_Sm2EncryptWithCert(bCert,raw));
    }
    
    //Please do not use the following APIs in your SDK. 
    public int UCM_InitializeHandleWithSeed(byte[] seed){
    	return priUCM_InitializeHandleWithSeed(seed);
    }
    
    public byte[] UCM_generate_random_bytes(int len){
    	return priUCM_generate_random_bytes(len);
    }
    
    public int UCM_UninitializeHandle(){
    	return priUCM_UninitializeHandle();
    }
    
}
